# Parodia Admin SDK

The Parodia Admin SDK is a comprehensive software development kit designed to simplify and streamline the integration of your application with an E-Commerce API. With Parodia, you can easily interact with various providers, such as authentication, cart management, customer data, order processing, and more, to build feature-rich e-commerce applications quickly and efficiently.

## Installation

To get started with Parodia, you can easily add it to your Dart project using [pub.dev](https://pub.dev/). Add the following dependency to your `pubspec.yaml` file:

```yaml
dependencies:
  parodia_admin: ^1.0.0 # Replace with the latest version
```

Then, run flutter pub get to fetch and install the package.

## Usage
Here's a basic example of how to get started with Parodia.
```dart
void main() => runApp(const MyApp());

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  @override
  Widget build(BuildContext context) {
    return ParodiaProvider(
      baseUrl: 'YOUR_BASE_URL',
      storeKey: 'YOUR_STORE_KEY',
      child: MaterialApp(
        title: 'Parodia Demo',
        home: Home(),
      ),
    );
  }
}

```

Thats it! Now you can use built-in providers 
Please refer to the package documentation and examples for more detailed information on how to use each provider and the available features.

## License
This package is open-source and available under the **BSD-3** License.

## Contact
If you have any questions, issues, or feedback, please feel free to contact us at support@parodia.com.

Thank you for choosing the Parodia Admin SDK for Flutter! 
We hope it helps you build amazing e-commerce applications.