import 'package:parodia_admin/core/dto/base.dto.dart';

class AddressDTO extends BaseDTO {
  String? country;
  String? state;
  String? city;
  String? district;
  String? neighborhood;
  String? street;
  String? buildingNo;
  String? doorNo;
  String? zipCode;
  double? latitude;
  double? longitude;
  String? openAddress;

  AddressDTO({
    super.id,
    super.createdAt,
    super.updatedAt,
    super.isActive,
    super.isDeleted,
    this.country,
    this.state,
    this.city,
    this.district,
    this.neighborhood,
    this.street,
    this.buildingNo,
    this.doorNo,
    this.zipCode,
    this.latitude,
    this.longitude,
    this.openAddress,
  });

  AddressDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    country = json['country'];
    state = json['state'];
    city = json['city'];
    district = json['district'];
    neighborhood = json['neighborhood'];
    street = json['street'];
    buildingNo = json['buildingNo'];
    doorNo = json['doorNo'];
    zipCode = json['zipCode'];
    latitude = json['latitude'];
    longitude = json['longitude'];
    openAddress = json['openAddress'];
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['country'] = country;
    data['state'] = state;
    data['city'] = city;
    data['district'] = district;
    data['neighborhood'] = neighborhood;
    data['street'] = street;
    data['buildingNo'] = buildingNo;
    data['doorNo'] = doorNo;
    data['zipCode'] = zipCode;
    data['latitude'] = latitude;
    data['longitude'] = longitude;
    data['openAddress'] = openAddress;
    return data;
  }
}
