import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/tag.dto.dart';

class BlogDTO extends BaseDTO {
  String? title;
  String? content;
  List<PhotoDTO>? photos;
  List<TagDTO>? tags;

  BlogDTO({
    super.id,
    super.createdAt,
    super.updatedAt,
    super.isActive,
    super.isDeleted,
    this.title,
    this.content,
    this.photos,
    this.tags,
  });

  BlogDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    title = json['title'];
    content = json['content'];
    if (json['photos'] != null) {
      photos = <PhotoDTO>[];
      json['photos'].forEach((v) {
        photos!.add(PhotoDTO.fromJson(v));
      });
    }
    if (json['tags'] != null) {
      tags = <TagDTO>[];
      json['tags'].forEach((v) {
        tags!.add(TagDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['title'] = title;
    data['content'] = content;
    if (photos != null) {
      data['photos'] = photos!.map((v) => v.toJson()).toList();
    }
    if (tags != null) {
      data['tags'] = tags!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
