import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/supplier.dto.dart';

class BrandDTO extends BaseDTO {
  String? name;
  String? slug;
  String? description;
  int? highlightRate;
  PhotoDTO? photo;
  List<SupplierDTO>? suppliers;

  BrandDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.slug,
      this.description,
      this.highlightRate,
      this.photo,
      this.suppliers});

  BrandDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    slug = json['slug'];
    description = json['description'];
    highlightRate = json['highlightRate'];
    if (json['photo'] != null) {
      photo = PhotoDTO.fromJson(json['photo']);
    }
    if (json['suppliers'] != null) {
      suppliers = <SupplierDTO>[];
      json['suppliers'].forEach((v) {
        suppliers!.add(SupplierDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();

    data['name'] = name;
    data['slug'] = slug;
    data['description'] = description;
    data['highlightRate'] = highlightRate;
    data['photo'] = photo;
    if (suppliers != null) {
      data['suppliers'] = suppliers!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
