import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/brand.dto.dart';
import 'package:parodia_admin/core/dto/category.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';
import 'package:parodia_admin/core/dto/tag.dto.dart';

class CampaignDTO extends BaseDTO {
  String? title;
  int? highlightRate;
  String? slug;
  String? link;
  String? description;
  String? discountStartDate;
  String? discountEndDate;
  int? limit;
  int? used;
  bool? showOnMain;
  String? type;
  String? priceType;
  int? productCount;
  int? freeProductCount;
  List<ProductDTO>? products;
  List<CategoryDTO>? categories;
  List<BrandDTO>? brands;
  List<TagDTO>? tags;
  PhotoDTO? photo;

  CampaignDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.title,
      this.highlightRate,
      this.slug,
      this.link,
      this.description,
      this.discountStartDate,
      this.discountEndDate,
      this.limit,
      this.used,
      this.showOnMain,
      this.type,
      this.priceType,
      this.productCount,
      this.freeProductCount,
      this.products,
      this.categories,
      this.brands,
      this.tags,
      this.photo});

  CampaignDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    title = json['title'];
    highlightRate = json['highlightRate'];
    slug = json['slug'];
    link = json['link'];
    description = json['description'];
    discountStartDate = json['discountStartDate'];
    discountEndDate = json['discountEndDate'];
    limit = json['limit'];
    used = json['used'];
    showOnMain = json['showOnMain'];
    type = json['type'];
    priceType = json['priceType'];
    productCount = json['productCount'];
    freeProductCount = json['freeProductCount'];
    if (json['products'] != null) {
      products = <ProductDTO>[];
      json['products'].forEach((v) {
        products!.add(ProductDTO.fromJson(v));
      });
    }
    if (json['categories'] != null) {
      categories = <CategoryDTO>[];
      json['categories'].forEach((v) {
        categories!.add(CategoryDTO.fromJson(v));
      });
    }
    if (json['brands'] != null) {
      brands = <BrandDTO>[];
      json['brands'].forEach((v) {
        brands!.add(BrandDTO.fromJson(v));
      });
    }
    if (json['tags'] != null) {
      tags = <TagDTO>[];
      json['tags'].forEach((v) {
        tags!.add(TagDTO.fromJson(v));
      });
    }
    photo = json['photo'] != null ? PhotoDTO.fromJson(json['photo']) : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();

    data['title'] = title;
    data['highlightRate'] = highlightRate;
    data['slug'] = slug;
    data['link'] = link;
    data['description'] = description;
    data['discountStartDate'] = discountStartDate;
    data['discountEndDate'] = discountEndDate;
    data['limit'] = limit;
    data['used'] = used;
    data['showOnMain'] = showOnMain;
    data['type'] = type;
    data['priceType'] = priceType;
    data['productCount'] = productCount;
    data['freeProductCount'] = freeProductCount;
    if (products != null) {
      data['products'] = products!.map((v) => v.toJson()).toList();
    }
    if (categories != null) {
      data['categories'] = categories!.map((v) => v.toJson()).toList();
    }
    if (brands != null) {
      data['brands'] = brands!.map((v) => v.toJson()).toList();
    }
    if (tags != null) {
      data['tags'] = tags!.map((v) => v.toJson()).toList();
    }
    if (photo != null) {
      data['photo'] = photo!.toJson();
    }
    return data;
  }
}
