import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';
import 'package:parodia_admin/core/dto/store.dto.dart';

class CatalogDTO extends BaseDTO {
  String? name;
  List<ProductDTO>? products;
  List<CatalogDTO>? assignedCatalogs;
  StoreDTO? store;

  CatalogDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.products,
      this.assignedCatalogs,
      this.store});

  CatalogDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    if (json['products'] != null) {
      products = <ProductDTO>[];
      json['products'].forEach((v) {
        products!.add(ProductDTO.fromJson(v));
      });
    }
    if (json['assignedCatalogs'] != null) {
      assignedCatalogs = <CatalogDTO>[];
      json['assignedCatalogs'].forEach((v) {
        assignedCatalogs!.add(CatalogDTO.fromJson(v));
      });
    }
    store = json['store'] != null ? StoreDTO.fromJson(json['store']) : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    if (products != null) {
      data['products'] = products!.map((v) => v.toJson()).toList();
    }
    if (assignedCatalogs != null) {
      data['assignedCatalogs'] =
          assignedCatalogs!.map((v) => v.toJson()).toList();
    }
    if (store != null) {
      data['store'] = store!.toJson();
    }
    return data;
  }
}
