import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/store.dto.dart';
import 'package:parodia_admin/core/dto/tax.dto.dart';

class CategoryDTO extends BaseDTO {
  String? name;
  String? slug;
  int? sortIndex;
  List<PhotoDTO>? photos;
  StoreDTO? store;
  TaxDTO? tax;
  List<CategoryDTO>? children;

  CategoryDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.slug,
      this.sortIndex,
      this.photos,
      this.store,
      this.tax,
      this.children});

  CategoryDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    slug = json['slug'];
    sortIndex = json['sortIndex'];
    if (json['photos'] != null) {
      photos = <PhotoDTO>[];
      json['photos'].forEach((v) {
        photos!.add(PhotoDTO.fromJson(v));
      });
    }
    store = json['store'] != null ? StoreDTO.fromJson(json['store']) : null;
    tax = json['tax'];
    if (json['children'] != null) {
      children = <CategoryDTO>[];
      json['children'].forEach((v) {
        children!.add(CategoryDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['slug'] = slug;
    data['sortIndex'] = sortIndex;
    if (photos != null) {
      data['photos'] = photos!.map((v) => v.toJson()).toList();
    }
    if (store != null) {
      data['store'] = store!.toJson();
    }
    data['tax'] = tax;
    if (children != null) {
      data['children'] = children!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
