import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/store.dto.dart';

class FeatureDTO extends BaseDTO {
  String? name;
  String? slug;
  String? description;
  PhotoDTO? icon;
  StoreDTO? store;
  List<FeatureDTO>? children;

  FeatureDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.slug,
      this.description,
      this.icon,
      this.store,
      this.children});

  FeatureDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    slug = json['slug'];
    description = json['description'];
    icon = json['icon'] != null ? PhotoDTO.fromJson(json['icon']) : null;
    store = json['store'] != null ? StoreDTO.fromJson(json['store']) : null;
    if (json['children'] != null) {
      children = <FeatureDTO>[];
      json['children'].forEach((v) {
        children!.add(FeatureDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['slug'] = slug;
    data['description'] = description;
    data['icon'] = icon;
    if (store != null) {
      data['store'] = store!.toJson();
    }
    if (children != null) {
      data['children'] = children!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
