class LoginDTO {
  String? type;
  List<Token>? token;

  LoginDTO({this.type, this.token});

  LoginDTO.fromJson(Map<String, dynamic> json) {
    type = json['type'];
    if (json['token'] != null) {
      token = <Token>[];
      json['token'].forEach((v) {
        token!.add(Token.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['type'] = type;
    if (token != null) {
      data['token'] = token!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Token {
  Store? store;
  String? token;

  Token({this.store, this.token});

  Token.fromJson(Map<String, dynamic> json) {
    store = json['store'] != null ? Store.fromJson(json['store']) : null;
    token = json['token'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    if (store != null) {
      data['store'] = store!.toJson();
    }
    data['token'] = token;
    return data;
  }
}

class Store {
  String? id;
  bool? isActive;
  String? type;
  Info? info;

  Store({this.id, this.isActive, this.type, this.info});

  Store.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    isActive = json['isActive'];
    type = json['type'];
    info = json['info'] != null ? Info.fromJson(json['info']) : null;
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['id'] = id;
    data['isActive'] = isActive;
    data['type'] = type;
    if (info != null) {
      data['info'] = info!.toJson();
    }
    return data;
  }
}

class Info {
  String? name;
  String? domain;

  Info({this.name, this.domain});

  Info.fromJson(Map<String, dynamic> json) {
    name = json['name'];
    domain = json['domain'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['name'] = name;
    data['domain'] = domain;
    return data;
  }
}
