import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/campaign.dto.dart';
import 'package:parodia_admin/core/dto/category.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';
import 'package:parodia_admin/core/dto/profile.dto.dart';

class NotificationDTO extends BaseDTO {
  String? title;
  String? description;
  String? photoUrl;
  String? oneSignalId;
  ProfileDTO? user;
  List<ProductDTO>? products;
  List<CategoryDTO>? categories;
  List<CampaignDTO>? campaigns;

  NotificationDTO({
    super.id,
    super.createdAt,
    super.updatedAt,
    super.isActive,
    super.isDeleted,
    this.title,
    this.description,
    this.photoUrl,
    this.oneSignalId,
    this.user,
    this.products,
    this.categories,
    this.campaigns,
  });

  NotificationDTO.fromJson(Map<String, dynamic> json) {
    super.id = json['id'];
    super.createdAt = json['createdAt'];
    super.updatedAt = json['updatedAt'];
    super.isActive = json['isActive'];
    super.isDeleted = json['isDeleted'];
    title = json['title'];
    description = json['description'];
    photoUrl = json['photoUrl'];
    oneSignalId = json['oneSignalId'];
    user = json['user'] != null ? ProfileDTO.fromJson(json['user']) : null;
    if (json['products'] != null) {
      products = <ProductDTO>[];
      json['products'].forEach((v) {
        products!.add(ProductDTO.fromJson(v));
      });
    }
    if (json['categories'] != null) {
      categories = <CategoryDTO>[];
      json['categories'].forEach((v) {
        categories!.add(CategoryDTO.fromJson(v));
      });
    }
    if (json['campaigns'] != null) {
      campaigns = <CampaignDTO>[];
      json['campaigns'].forEach((v) {
        campaigns!.add(CampaignDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['id'] = super.id;
    data['createdAt'] = super.createdAt;
    data['updatedAt'] = super.updatedAt;
    data['isActive'] = super.isActive;
    data['isDeleted'] = super.isDeleted;
    data['title'] = title;
    data['description'] = description;
    data['photoUrl'] = photoUrl;
    data['oneSignalId'] = oneSignalId;
    if (user != null) {
      data['user'] = user!.toJson();
    }
    if (products != null) {
      data['products'] = products!.map((v) => v.toJson()).toList();
    }
    if (categories != null) {
      data['categories'] = categories!.map((v) => v.toJson()).toList();
    }
    if (campaigns != null) {
      data['campaigns'] = campaigns!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
