import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo_folder.dto.dart';

class PhotoDTO extends BaseDTO {
  String? url;
  String? name;
  String? description;
  String? alt;
  PhotoFolderDTO? folder;

  PhotoDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.url,
      this.name,
      this.description,
      this.alt,
      this.folder});

  PhotoDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    url = json['url'];
    name = json['name'];
    description = json['description'];
    alt = json['alt'];
    folder =
        json['folder'] != null ? PhotoFolderDTO.fromJson(json['folder']) : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['url'] = url;
    data['name'] = name;
    data['description'] = description;
    data['alt'] = alt;
    if (folder != null) {
      data['folder'] = folder!.toJson();
    }
    return data;
  }
}
