import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/store.dto.dart';

class PhotoFolderDTO extends BaseDTO {
  String? name;
  List<PhotoFolderDTO>? children;
  List<PhotoDTO>? photos;
  StoreDTO? store;

  PhotoFolderDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.children,
      this.photos,
      this.store});

  PhotoFolderDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    store = json['store'] != null ? StoreDTO.fromJson(json['store']) : null;
    if (json['children'] != null) {
      children = <PhotoFolderDTO>[];
      json['children'].forEach((v) {
        children!.add(PhotoFolderDTO.fromJson(v));
      });
    }
    if (json['photos'] != null) {
      photos = <PhotoDTO>[];
      json['photos'].forEach((v) {
        photos!.add(PhotoDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    if (store != null) {
      data['store'] = store!.toJson();
    }
    if (children != null) {
      data['children'] = children!.map((v) => v.toJson()).toList();
    }
    if (photos != null) {
      data['photos'] = photos!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
