import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/catalog.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';

class ProductCatalogDTO extends BaseDTO {
  bool? canPublish;
  CatalogDTO? catalog;
  ProductDTO? product;

  ProductCatalogDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.canPublish,
      this.catalog,
      this.product});

  ProductCatalogDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    canPublish = json['canPublish'];
    catalog =
        json['catalog'] != null ? CatalogDTO.fromJson(json['catalog']) : null;
    product =
        json['product'] != null ? ProductDTO.fromJson(json['product']) : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['canPublish'] = canPublish;
    if (catalog != null) {
      data['catalog'] = catalog!.toJson();
    }
    if (product != null) {
      data['product'] = product!.toJson();
    }
    return data;
  }
}
