import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/brand.dto.dart';
import 'package:parodia_admin/core/dto/category.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';
import 'package:parodia_admin/core/dto/supplier.dto.dart';

class ProductDetailDTO extends BaseDTO {
  String? type;
  int? highlightRate;
  bool? useStock;
  List<ProductDTO>? products;
  List<CategoryDTO>? categories;
  BrandDTO? brand;
  List<SupplierDTO>? suppliers;

  ProductDetailDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.type,
      this.highlightRate,
      this.useStock,
      this.products,
      this.categories,
      this.brand,
      this.suppliers});

  ProductDetailDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    type = json['type'];
    highlightRate = json['highlightRate'];
    useStock = json['useStock'];
    if (json['products'] != null) {
      products = <ProductDTO>[];
      json['products'].forEach((v) {
        products!.add(ProductDTO.fromJson(v));
      });
    }
    if (json['categories'] != null) {
      categories = <CategoryDTO>[];
      json['categories'].forEach((v) {
        categories!.add(CategoryDTO.fromJson(v));
      });
    }
    brand = json['brand'] != null ? BrandDTO.fromJson(json['brand']) : null;
    if (json['suppliers'] != null) {
      suppliers = <SupplierDTO>[];
      json['suppliers'].forEach((v) {
        suppliers!.add(SupplierDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['type'] = type;
    data['highlightRate'] = highlightRate;
    data['useStock'] = useStock;
    if (products != null) {
      data['products'] = products!.map((v) => v.toJson()).toList();
    }
    if (categories != null) {
      data['categories'] = categories!.map((v) => v.toJson()).toList();
    }
    if (brand != null) {
      data['brand'] = brand!.toJson();
    }
    if (suppliers != null) {
      data['suppliers'] = suppliers!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
