import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/product_price.dto.dart';

class ProductPriceGroupDTO extends BaseDTO {
  String? name;
  String? locale;
  String? currency;
  List<ProductPriceDTO>? prices;

  ProductPriceGroupDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.locale,
      this.currency,
      this.prices});

  ProductPriceGroupDTO.fromJson(Map<String, dynamic> json)
      : super.fromJson(json) {
    name = json['name'];
    locale = json['locale'];
    currency = json['currency'];
    if (json['prices'] != null) {
      prices = <ProductPriceDTO>[];
      json['prices'].forEach((v) {
        prices!.add(ProductPriceDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['locale'] = locale;
    data['currency'] = currency;
    if (prices != null) {
      data['prices'] = prices!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
