import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/category.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';

class PromoCodeDTO extends BaseDTO {
  String? code;
  int? limit;
  int? used;
  int? amount;
  String? amountType;
  String? type;
  List<ProductDTO>? products;
  List<CategoryDTO>? categories;

  PromoCodeDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.code,
      this.limit,
      this.used,
      this.amount,
      this.amountType,
      this.type,
      this.products,
      this.categories});

  PromoCodeDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    code = json['code'];
    limit = json['limit'];
    used = json['used'];
    amount = json['amount'];
    amountType = json['amountType'];
    type = json['type'];
    if (json['products'] != null) {
      products = <ProductDTO>[];
      json['products'].forEach((v) {
        products!.add(ProductDTO.fromJson(v));
      });
    }
    if (json['categories'] != null) {
      categories = <CategoryDTO>[];
      json['categories'].forEach((v) {
        categories!.add(CategoryDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['code'] = code;
    data['limit'] = limit;
    data['used'] = used;
    data['amount'] = amount;
    data['amountType'] = amountType;
    data['type'] = type;
    if (products != null) {
      data['products'] = products!.map((v) => v.toJson()).toList();
    }
    if (categories != null) {
      data['categories'] = categories!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
