import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/profile.dto.dart';

class RatingDTO extends BaseDTO {
  int? rate;
  String? comment;
  bool? isVerified;
  ProfileDTO? user;
  List<PhotoDTO>? photos;

  RatingDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.rate,
      this.comment,
      this.isVerified,
      this.user,
      this.photos});

  RatingDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    rate = json['rate'];
    comment = json['comment'];
    isVerified = json['isVerified'];
    user = json['user'] != null ? ProfileDTO.fromJson(json['user']) : null;
    if (json['photos'] != null) {
      photos = <PhotoDTO>[];
      json['photos'].forEach((v) {
        photos!.add(PhotoDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['rate'] = rate;
    data['comment'] = comment;
    data['isVerified'] = isVerified;
    if (user != null) {
      data['user'] = user!.toJson();
    }
    if (photos != null) {
      data['photos'] = photos!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
