import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/role_group.dto.dart';

class RoleDTO extends BaseDTO {
  String? name;
  String? permissions;
  RoleGroupDTO? group;

  RoleDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.permissions,
      this.group});

  RoleDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    permissions = json['permissions'];
    group = json['group'] != null ? RoleGroupDTO.fromJson(json['group']) : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['permissions'] = permissions;
    if (group != null) {
      data['group'] = group!.toJson();
    }
    return data;
  }
}
