import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/role.dto.dart';

class RoleGroupDTO extends BaseDTO {
  String? name;
  List<RoleDTO>? roles;

  RoleGroupDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.roles});

  RoleGroupDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    if (json['roles'] != null) {
      roles = <RoleDTO>[];
      json['roles'].forEach((v) {
        roles!.add(RoleDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    if (roles != null) {
      data['roles'] = roles!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
