import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/product_price.dto.dart';

class ShipmentMethodDTO extends BaseDTO {
  String? name;
  String? logoURL;
  String? type;
  String? calculationType;
  int? shipmentEstimatedDay;
  bool? showShipmentEstimatedDay;
  int? freeShipmentCargoLimit;
  bool? cashOnDelivery;
  List<ProductPriceDTO>? prices;

  ShipmentMethodDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.logoURL,
      this.type,
      this.calculationType,
      this.shipmentEstimatedDay,
      this.showShipmentEstimatedDay,
      this.freeShipmentCargoLimit,
      this.cashOnDelivery,
      this.prices});

  ShipmentMethodDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    logoURL = json['logoURL'];
    type = json['type'];
    calculationType = json['calculationType'];
    shipmentEstimatedDay = json['shipmentEstimatedDay'];
    showShipmentEstimatedDay = json['showShipmentEstimatedDay'];
    freeShipmentCargoLimit = json['freeShipmentCargoLimit'];
    cashOnDelivery = json['cashOnDelivery'];
    if (json['prices'] != null) {
      prices = <ProductPriceDTO>[];
      json['prices'].forEach((v) {
        prices!.add(ProductPriceDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['logoURL'] = logoURL;
    data['type'] = type;
    data['calculationType'] = calculationType;
    data['shipmentEstimatedDay'] = shipmentEstimatedDay;
    data['showShipmentEstimatedDay'] = showShipmentEstimatedDay;
    data['freeShipmentCargoLimit'] = freeShipmentCargoLimit;
    data['cashOnDelivery'] = cashOnDelivery;
    if (prices != null) {
      data['prices'] = prices!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
