import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';
import 'package:parodia_admin/core/dto/supplier.dto.dart';
import 'package:parodia_admin/core/dto/warehouse.dto.dart';

class StockDTO extends BaseDTO {
  String? stockType;
  String? type;
  String? status;
  bool? include;
  String? note;
  String? sku;
  int? quantity;
  String? startDate;
  String? endDate;
  String? purchaseDate;
  int? purchasePrice;
  String? purchaseCurrency;
  String? transactionDate;
  String? storeId;
  String? productId;
  String? warehouseId;
  String? transferId;
  String? supplierId;
  String? inStockId;
  String? productName;
  String? productBarcode;
  String? productSlug;
  String? warehouseName;
  String? supplierName;
  ProductDTO? product;
  SupplierDTO? supplier;
  WarehouseDTO? warehouse;

  StockDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.stockType,
      this.type,
      this.status,
      this.include,
      this.note,
      this.sku,
      this.quantity,
      this.startDate,
      this.endDate,
      this.purchaseDate,
      this.purchasePrice,
      this.purchaseCurrency,
      this.transactionDate,
      this.storeId,
      this.productId,
      this.warehouseId,
      this.transferId,
      this.supplierId,
      this.inStockId,
      this.productName,
      this.productBarcode,
      this.productSlug,
      this.warehouseName,
      this.supplierName,
      this.product,
      this.supplier,
      this.warehouse});

  StockDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    stockType = json['stockType'];
    type = json['type'];
    status = json['status'];
    include = json['include'];
    note = json['note'];
    sku = json['sku'];
    quantity = json['quantity'];
    startDate = json['startDate'];
    endDate = json['endDate'];
    purchaseDate = json['purchaseDate'];
    purchasePrice = json['purchasePrice'];
    purchaseCurrency = json['purchaseCurrency'];
    transactionDate = json['transactionDate'];
    storeId = json['storeId'];
    productId = json['productId'];
    warehouseId = json['warehouseId'];
    transferId = json['transferId'];
    supplierId = json['supplierId'];
    inStockId = json['inStockId'];
    productName = json['productName'];
    productBarcode = json['productBarcode'];
    productSlug = json['productSlug'];
    warehouseName = json['warehouseName'];
    supplierName = json['supplierName'];
    product =
        json['product'] != null ? ProductDTO.fromJson(json['product']) : null;
    supplier = json['supplier'] != null
        ? SupplierDTO.fromJson(json['supplier'])
        : null;
    warehouse = json['warehouse'] != null
        ? WarehouseDTO.fromJson(json['warehouse'])
        : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['stockType'] = stockType;
    data['type'] = type;
    data['status'] = status;
    data['include'] = include;
    data['note'] = note;
    data['sku'] = sku;
    data['quantity'] = quantity;
    data['startDate'] = startDate;
    data['endDate'] = endDate;
    data['purchaseDate'] = purchaseDate;
    data['purchasePrice'] = purchasePrice;
    data['purchaseCurrency'] = purchaseCurrency;
    data['transactionDate'] = transactionDate;
    data['storeId'] = storeId;
    data['productId'] = productId;
    data['warehouseId'] = warehouseId;
    data['transferId'] = transferId;
    data['supplierId'] = supplierId;
    data['inStockId'] = inStockId;
    data['productName'] = productName;
    data['productBarcode'] = productBarcode;
    data['productSlug'] = productSlug;
    data['warehouseName'] = warehouseName;
    data['supplierName'] = supplierName;
    if (product != null) {
      data['product'] = product!.toJson();
    }
    if (supplier != null) {
      data['supplier'] = supplier!.toJson();
    }
    if (warehouse != null) {
      data['warehouse'] = warehouse!.toJson();
    }
    return data;
  }
}
