import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/product.dto.dart';

class StockListDTO extends BaseDTO {
  int? quantity;
  String? startDate;
  String? endDate;
  ProductDTO? product;

  StockListDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.quantity,
      this.startDate,
      this.endDate,
      this.product});

  StockListDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    quantity = json['quantity'];
    startDate = json['startDate'];
    endDate = json['endDate'];
    product =
        json['product'] != null ? ProductDTO.fromJson(json['product']) : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['quantity'] = quantity;
    data['startDate'] = startDate;
    data['endDate'] = endDate;
    if (product != null) {
      data['product'] = product!.toJson();
    }
    return data;
  }
}
