import 'package:parodia_admin/core/dto/base.dto.dart';

class StoreSettingCurrencyDTO extends BaseDTO {
  String? baseCurrency;
  List<Rates>? rates;

  StoreSettingCurrencyDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.baseCurrency,
      this.rates});

  StoreSettingCurrencyDTO.fromJson(Map<String, dynamic> json)
      : super.fromJson(json) {
    baseCurrency = json['baseCurrency'];
    if (json['rates'] != null) {
      rates = <Rates>[];
      json['rates'].forEach((v) {
        rates!.add(Rates.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['baseCurrency'] = baseCurrency;
    if (rates != null) {
      data['rates'] = rates!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class Rates {
  String? id;
  String? createdAt;
  bool? isFixed;
  String? currency;
  double? rate;

  Rates({this.id, this.createdAt, this.isFixed, this.currency, this.rate});

  Rates.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    createdAt = json['createdAt'];
    isFixed = json['isFixed'];
    currency = json['currency'];
    rate = json['rate'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['id'] = id;
    data['createdAt'] = createdAt;
    data['isFixed'] = isFixed;
    data['currency'] = currency;
    data['rate'] = rate;
    return data;
  }
}
