import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/brand.dto.dart';

class SupplierDTO extends BaseDTO {
  String? name;
  List<BrandDTO>? brands;
  // List<void>? productGroups;

  SupplierDTO({
    super.id,
    super.createdAt,
    super.updatedAt,
    super.isActive,
    super.isDeleted,
    this.name,
    this.brands,
    // this.productGroups,
  });

  SupplierDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    if (json['brands'] != null) {
      brands = <BrandDTO>[];
      json['brands'].forEach((v) {
        brands!.add(BrandDTO.fromJson(v));
      });
    }
    // if (json['productGroups'] != null) {
    //   productGroups = <Null>[];
    //   json['productGroups'].forEach((v) {
    //     productGroups!.add(void.fromJson(v));
    //   });
    // }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    if (brands != null) {
      data['brands'] = brands!.map((v) => v.toJson()).toList();
    }
    // if (productGroups != null) {
    //   data['productGroups'] =
    //       productGroups!.map((v) => v.toJson()).toList();
    // }
    return data;
  }
}
