import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/photo.dto.dart';
import 'package:parodia_admin/core/dto/store.dto.dart';

class TagDTO extends BaseDTO {
  String? name;
  String? description;
  String? slug;
  String? type;
  PhotoDTO? photo;
  StoreDTO? store;
  List<TagDTO>? children;

  TagDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.description,
      this.slug,
      this.type,
      this.photo,
      this.store,
      this.children});

  TagDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    description = json['description'];
    slug = json['slug'];
    type = json['type'];
    photo = json['photo'] != null ? PhotoDTO.fromJson(json['photo']) : null;
    store = json['store'] != null ? StoreDTO.fromJson(json['store']) : null;
    if (json['children'] != null) {
      children = <TagDTO>[];
      json['children'].forEach((v) {
        children!.add(TagDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['description'] = description;
    data['slug'] = slug;
    data['type'] = type;
    if (photo != null) {
      data['photo'] = photo!.toJson();
    }
    if (store != null) {
      data['store'] = store!.toJson();
    }
    if (children != null) {
      data['children'] = children!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
