import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/vehicle.dto.dart';
import 'package:parodia_admin/core/dto/warehouse.dto.dart';

class TransferDTO extends BaseDTO {
  String? note;
  String? status;
  VehicleDTO? vehicle;
  WarehouseDTO? startWarehouse;
  WarehouseDTO? destinationWarehouse;

  TransferDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.note,
      this.status,
      this.vehicle,
      this.startWarehouse,
      this.destinationWarehouse});

  TransferDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    note = json['note'];
    status = json['status'];
    vehicle =
        json['vehicle'] != null ? VehicleDTO.fromJson(json['vehicle']) : null;
    startWarehouse = json['startWarehouse'] != null
        ? WarehouseDTO.fromJson(json['startWarehouse'])
        : null;
    destinationWarehouse = json['destinationWarehouse'] != null
        ? WarehouseDTO.fromJson(json['destinationWarehouse'])
        : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['note'] = note;
    data['status'] = status;
    if (vehicle != null) {
      data['vehicle'] = vehicle!.toJson();
    }
    if (startWarehouse != null) {
      data['startWarehouse'] = startWarehouse!.toJson();
    }
    if (destinationWarehouse != null) {
      data['destinationWarehouse'] = destinationWarehouse!.toJson();
    }
    return data;
  }
}
