import 'package:parodia_admin/core/dto/base.dto.dart';
import 'package:parodia_admin/core/dto/product_price_group.dto.dart';
import 'package:parodia_admin/core/dto/profile.dto.dart';

class UserGroupDTO extends BaseDTO {
  String? name;
  int? baseDiscountPercentage;
  ProductPriceGroupDTO? priceGroup;
  List<ProfileDTO>? users;

  UserGroupDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.baseDiscountPercentage,
      this.priceGroup,
      this.users});

  UserGroupDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    baseDiscountPercentage = json['baseDiscountPercentage'];
    priceGroup = json['priceGroup'] != null
        ? ProductPriceGroupDTO.fromJson(json['priceGroup'])
        : null;
    if (json['users'] != null) {
      users = <ProfileDTO>[];
      json['users'].forEach((v) {
        users!.add(ProfileDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['baseDiscountPercentage'] = baseDiscountPercentage;
    if (priceGroup != null) {
      data['priceGroup'] = priceGroup!.toJson();
    }
    if (users != null) {
      data['users'] = users!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
