import 'package:parodia_admin/core/dto/variant.dto.dart';
import 'package:parodia_admin/core/dto/base.dto.dart';

class VariantGroupDTO extends BaseDTO {
  String? name;
  bool? isGrouped;
  List<VariantDTO>? variants;

  VariantGroupDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.isGrouped,
      this.variants});

  VariantGroupDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    isGrouped = json['isGrouped'];
    if (json['variants'] != null) {
      variants = <VariantDTO>[];
      json['variants'].forEach((v) {
        variants!.add(VariantDTO.fromJson(v));
      });
    }
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    data['isGrouped'] = isGrouped;
    if (variants != null) {
      data['variants'] = variants!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}
