import 'package:parodia_admin/core/dto/address.dto.dart';
import 'package:parodia_admin/core/dto/base.dto.dart';

class WarehouseDTO extends BaseDTO {
  String? name;
  AddressDTO? address;

  WarehouseDTO(
      {super.id,
      super.createdAt,
      super.updatedAt,
      super.isActive,
      super.isDeleted,
      this.name,
      this.address});

  WarehouseDTO.fromJson(Map<String, dynamic> json) : super.fromJson(json) {
    name = json['name'];
    address =
        json['address'] != null ? AddressDTO.fromJson(json['address']) : null;
  }

  @override
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = super.toJson();
    data['name'] = name;
    if (address != null) {
      data['address'] = address!.toJson();
    }
    return data;
  }
}
