// POST
// /api/v1/auth/login

// POST
// /api/v1/auth/register/{storeId}

// POST
// /api/v1/auth/register

// POST
// /api/v1/auth/password/send-code

// POST
// /api/v1/auth/password/check-code

// POST
// /api/v1/auth/password/reset-password

import 'package:parodia_admin/core/dto/login.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';

class AuthRepository {
  ParodiaHTTP? _http;

  AuthRepository(ParodiaHTTP http) {
    _http = http;
  }

  Future<ResponseItemDTO<LoginDTO>> login({LoginBody? loginBody}) async {
    final response = await _http!.request(
      requestType: RequestType.post,
      path: '/auth/login',
      data: loginBody,
    );

    return ResponseItemDTO<LoginDTO>(
      response: response,
      fromJson: LoginDTO.fromJson,
    );
  }

  Future<ResponseItemDTO> sendCode({ForgotPasswordBody? body}) async {
    final response = await _http!.request(
      requestType: RequestType.post,
      path: '/auth/password/send-code',
      data: body,
    );

    return ResponseItemDTO(response: response);
  }

  Future<ResponseItemDTO> checkCode({ForgotPasswordBody? body}) async {
    final response = await _http!.request(
      requestType: RequestType.post,
      path: '/auth/password/check-code',
      data: body,
    );

    return ResponseItemDTO(response: response);
  }

  Future<ResponseItemDTO> resetPassword({ForgotPasswordBody? body}) async {
    final response = await _http!.request(
      requestType: RequestType.post,
      path: '/auth/password/reset-password',
      data: body,
    );

    return ResponseItemDTO(response: response);
  }
}
