// GET
// /api/v1/global/cities

// GET
// /api/v1/global/cities/{city}/districts

// GET
// /api/v1/global/cities/{city}/districts/{district}/neighborhoods

import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';

class CityRepository {
  ParodiaHTTP? _http;

  CityRepository(ParodiaHTTP http) {
    _http = http;
  }

  Future<ResponseItemDTO> getCities() async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/global/cities',
    );

    return ResponseItemDTO(
      response: response,
      isSingleData: true,
    );
  }

  Future<ResponseItemDTO> getDistricts({String? city}) async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/global/cities/$city/districts',
    );

    return ResponseItemDTO(
      response: response,
      isSingleData: true,
    );
  }

  Future<ResponseItemDTO> getNeighborhoods(
      {String? city, String? district}) async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/global/cities/$city/districts/$district/neighborhoods',
    );

    return ResponseItemDTO(
      response: response,
      isSingleData: true,
    );
  }
}
