// POST
// /api/v1/dashboard/dashboard/orders/refunds/{orderId}



// PUT
// /api/v1/dashboard/dashboard/orders/refunds/{id}

import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
class OrderRefundRepository {
  ParodiaHTTP? _http;

  OrderRefundRepository(ParodiaHTTP http) {
    _http = http;
  }

  Future<ResponseItemDTO> create({String? orderId, OrderRefundBody? refundBody}) async {
    final response = await _http!.request(
      requestType: RequestType.post,
      path: '/dashboard/orders/refunds',
      param: orderId,
      data: refundBody,
    );

    return ResponseItemDTO(
      response: response,
    );
  }

  Future<ResponseItemDTO> update({String? id,OrderRefundBody? refundBody}) async {
    final response = await _http!.request(
      requestType: RequestType.put,
      path: '/dashboard/orders/refunds',
      param: id,
      data: refundBody,
    );

    return ResponseItemDTO(
      response: response,
    );
  }
}
