// GET
// /api/v1/dashboard/dashboard/stocks

import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/stock.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/query.model.dart';

class StockRepository {
  ParodiaHTTP? _http;

  StockRepository(ParodiaHTTP http) {
    _http = http;
  }

  Future<ResponseListDTO<StockDTO>> get({StockQuery? query}) async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/dashboard/stocks',
      query: query,
    );

    return ResponseListDTO<StockDTO>(
      response: response,
      fromJson: StockDTO.fromJson,
    );
  }
}
