// GET
// /api/v1/dashboard/dashboard/stores/settings

// PUT
// /api/v1/dashboard/dashboard/stores/settings

import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/store_setting.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';

class StoreSettingRepository {
  ParodiaHTTP? _http;

  StoreSettingRepository(ParodiaHTTP http) {
    _http = http;
  }

  Future<ResponseItemDTO<StoreSettingDTO>> get() async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/dashboard/stores/settings',
    );

    return ResponseItemDTO<StoreSettingDTO>(
      response: response,
      fromJson: StoreSettingDTO.fromJson,
    );
  }

  Future<ResponseItemDTO> update({StoreSettingPutBody? storeSetting}) async {
    final response = await _http!.request(
      requestType: RequestType.put,
      path: '/dashboard/stores/settings',
      data: storeSetting,
    );

    return ResponseItemDTO(
      response: response,
    );
  }
}
