// GET
// /api/v1/dashboard/dashboard/stores/settings/currencies

// PUT
// /api/v1/dashboard/dashboard/stores/settings/currencies

import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/store_setting_currency.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';

class StoreSettingCurrencyRepository {
  ParodiaHTTP? _http;

  StoreSettingCurrencyRepository(ParodiaHTTP http) {
    _http = http;
  }

  Future<ResponseItemDTO<StoreSettingCurrencyDTO>> get() async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/dashboard/stores/settings/currencies',
    );

    return ResponseItemDTO<StoreSettingCurrencyDTO>(
      response: response,
      fromJson: StoreSettingCurrencyDTO.fromJson,
    );
  }

  Future<ResponseItemDTO> update(
      {StoreSettingCurrencyPutBody? storeSettingCurrency}) async {
    final response = await _http!.request(
      requestType: RequestType.put,
      path: '/dashboard/stores/settings/currencies',
      data: storeSettingCurrency,
    );

    return ResponseItemDTO(
      response: response,
    );
  }
}
