// GET
// /api/v1/dashboard/dashboard/taxes/{id}



// PUT
// /api/v1/dashboard/dashboard/taxes/{id}



// DELETE
// /api/v1/dashboard/dashboard/taxes/{id}



// GET
// /api/v1/dashboard/dashboard/taxes



// POST
// /api/v1/dashboard/dashboard/taxes



// POST
// /api/v1/dashboard/dashboard/taxes/{id}/recover

import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/tax.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
class TaxRepository {
  ParodiaHTTP? _http;

  TaxRepository(ParodiaHTTP http) {
    _http = http;
  }

  Future<ResponseItemDTO<TaxDTO>> getById({String? id}) async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/dashboard/taxes',
      param: id,
    );

    return ResponseItemDTO<TaxDTO>(
      response: response,
      fromJson: TaxDTO.fromJson,
    );
  }

  Future<ResponseListDTO<TaxDTO>> getAll({ StoreQuery? query,}) async {
    final response = await _http!.request(
      requestType: RequestType.get,
      path: '/dashboard/taxes',
      query: query,
    );

    return ResponseListDTO<TaxDTO>(
      response: response,
      fromJson: TaxDTO.fromJson,
    );
  }

  Future<ResponseItemDTO> create({TaxBody? tax}) async {
    final response = await _http!.request(
      requestType: RequestType.post,
      path: '/dashboard/taxes',
      data: tax,
    );

    return ResponseItemDTO(
      response: response,
      fromJson: null,
    );
  }

  Future<ResponseItemDTO> update({String? id, TaxBody? tax}) async {
    final response = await _http!.request(
      requestType: RequestType.put,
      path: '/dashboard/taxes',
      param: id,
      data: tax,
    );

    return ResponseItemDTO(
      response: response,
      fromJson: null,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    final response = await _http!.request(
      requestType: RequestType.delete,
      path: '/dashboard/taxes',
      param: id,
    );

    return ResponseItemDTO(
      response: response,
      fromJson: null,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    final response = await _http!.request(
      requestType: RequestType.post,
      path: '/dashboard/taxes/$id/recover',
    );

    return ResponseItemDTO(
      response: response,
      fromJson: null,
    );
  }
}
