import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/login.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/repository/auth.repository.dart';

class ParodiaAuthProvider with ChangeNotifier {
  AuthRepository? _repository;

  ParodiaAuthProvider();
  ParodiaAuthProvider.init(ParodiaHTTP http) {
    _repository = AuthRepository(http);
  }

  Future<ResponseItemDTO<LoginDTO>> login({LoginBody? loginBody}) async {
    return await _repository!.login(
      loginBody: loginBody,
    );
  }

  Future<ResponseItemDTO> sendCode({ForgotPasswordBody? body}) async {
    return await _repository!.sendCode(
      body: body,
    );
  }

  Future<ResponseItemDTO> checkCode({ForgotPasswordBody? body}) async {
    return await _repository!.checkCode(
      body: body,
    );
  }

  Future<ResponseItemDTO> resetPassword({ForgotPasswordBody? body}) async {
    return await _repository!.resetPassword(
      body: body,
    );
  }
}
