import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/blog.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/blog.repository.dart';

class ParodiaBlogProvider with ChangeNotifier {
  BlogRepository? _repository;

  ParodiaBlogProvider();
  ParodiaBlogProvider.init(ParodiaHTTP http) {
    _repository = BlogRepository(http);
  }

  Future<ResponseItemDTO<BlogDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<BlogDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({BlogBody? blog}) async {
    return await _repository!.create(
      blog: blog,
    );
  }

  Future<ResponseItemDTO> update({String? id, BlogBody? blog}) async {
    return await _repository!.update(
      id: id,
      blog: blog,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
