import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/campaign.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/campaign.repository.dart';

class ParodiaCampaignProvider with ChangeNotifier {
  CampaignRepository? _repository;

  ParodiaCampaignProvider();
  ParodiaCampaignProvider.init(ParodiaHTTP http) {
    _repository = CampaignRepository(http);
  }

  Future<ResponseItemDTO<CampaignDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<CampaignDTO>> getAll({CampaignQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({CampaignBody? campaign}) async {
    return await _repository!.create(
      campaign: campaign,
    );
  }

  Future<ResponseItemDTO> update({String? id, CampaignBody? campaign}) async {
    return await _repository!.update(
      id: id,
      campaign: campaign,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }

  Future<ResponseItemDTO> slugify({String? id}) async {
    return await _repository!.slugify(
      id: id,
    );
  }
}
