import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/catalog.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/catalog.repository.dart';

class ParodiaCatalogProvider with ChangeNotifier {
  CatalogRepository? _repository;

  ParodiaCatalogProvider();
  ParodiaCatalogProvider.init(ParodiaHTTP http) {
    _repository = CatalogRepository(http);
  }

  Future<ResponseItemDTO<CatalogDTO>> getById({String? id}) async {
    return await _repository!.getById(id: id);
  }

  Future<ResponseListDTO<CatalogDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(query: query);
  }

  Future<ResponseItemDTO> create({CatalogBody? catalog}) async {
    return await _repository!.create(catalog: catalog);
  }

  Future<ResponseItemDTO> update({String? id, CatalogBody? catalog}) async {
    return await _repository!.update(id: id, catalog: catalog);
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(id: id);
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(id: id);
  }
}
