import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/repository/city.repository.dart';

class ParodiaCityProvider with ChangeNotifier {
  CityRepository? _repository;

  ParodiaCityProvider();
  ParodiaCityProvider.init(ParodiaHTTP http) {
    _repository = CityRepository(http);
  }

  Future<ResponseItemDTO> getCities() async {
    return await _repository!.getCities();
  }

  Future<ResponseItemDTO> getDistricts({String? city}) async {
    return await _repository!.getDistricts(city: city);
  }

  Future<ResponseItemDTO> getNeighborhoods(
      {String? city, String? district}) async {
    return await _repository!.getNeighborhoods(city: city, district: district);
  }
}
