import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/stock.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/inStock.repository.dart';

class ParodiaInStockProvider with ChangeNotifier {
  InStockRepository? _repository;

  ParodiaInStockProvider();
  ParodiaInStockProvider.init(ParodiaHTTP http) {
    _repository = InStockRepository(http);
  }

  Future<ResponseItemDTO<StockDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }
  Future<ResponseListDTO<StockDTO>> getAll({StockQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }
  Future<ResponseItemDTO> create({InStockBody? inStock}) async {
    return await _repository!.create(
      inStock: inStock,
    );
  }
  Future<ResponseItemDTO> update({String? id, InStockBody? inStock}) async {
    return await _repository!.update(
      id: id,
      inStock: inStock,
    );
  }
  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }
  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
