import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/mail_template.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/mailTemplate.repository.dart';

class ParodiaMailTemplateProvider with ChangeNotifier {
  MailTemplateRepository? _repository;

  ParodiaMailTemplateProvider();
  ParodiaMailTemplateProvider.init(ParodiaHTTP http) {
    _repository = MailTemplateRepository(http);
  }
  Future<ResponseItemDTO<MailTemplateDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<MailTemplateDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({MailTemplateBody? mailTemplate}) async {
    return await _repository!.create(
      mailTemplate: mailTemplate,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, MailTemplateBody? mailTemplate}) async {
    return await _repository!.update(
      id: id,
      mailTemplate: mailTemplate,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
