import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/notification.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/repository/notification.repository.dart';

class ParodiaNotificationProvider with ChangeNotifier {
  NotificationRepository? _repository;

  ParodiaNotificationProvider();
  ParodiaNotificationProvider.init(ParodiaHTTP http) {
    _repository = NotificationRepository(http);
  }

  Future<ResponseItemDTO<NotificationDTO>> getById(String id) async {
    return await _repository!.getById(
      id,
    );
  }

  Future<ResponseItemDTO> create({NotificationBody? body}) async {
    return await _repository!.create(
      body: body,
    );
  }

  Future<ResponseItemDTO> update({String? id, NotificationBody? body}) async {
    return await _repository!.update(
      id: id,
      body: body,
    );
  }

  Future<ResponseItemDTO> delete(String id) async {
    return await _repository!.delete(
      id,
    );
  }

  Future<ResponseItemDTO> recover(String id) async {
    return await _repository!.recover(
      id,
    );
  }

  Future<ResponseListDTO<NotificationDTO>> getAll() async {
    return await _repository!.getAll();
  }

  Future<ResponseItemDTO> sendToAll({NotificationBody? body}) async {
    return await _repository!.sendToAll(
      body: body,
    );
  }
}
