import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/order.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/order.repository.dart';

class ParodiaOrderProvider with ChangeNotifier {
  OrderRepository? _repository;

  ParodiaOrderProvider();
  ParodiaOrderProvider.init(ParodiaHTTP http) {
    _repository = OrderRepository(http);
  }
  Future<ResponseItemDTO<OrderDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<OrderDTO>> getAll({OrderQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> update({String? id, OrderPutBody? order}) async {
    return await _repository!.update(
      id: id,
      order: order,
    );
  }

  Future<ResponseItemDTO> assign({String? id, OrderAssignBody? body}) async {
    return await _repository!.assign(
      id: id,
      body: body,
    );
  }
}
