import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/repository/orderRefund.repository.dart';

class ParodiaOrderRefundProvider with ChangeNotifier {
  OrderRefundRepository? _repository;

  ParodiaOrderRefundProvider();
  ParodiaOrderRefundProvider.init(ParodiaHTTP http) {
    _repository = OrderRefundRepository(http);
  }

  Future<ResponseItemDTO> create(
      {String? orderId, OrderRefundBody? refundBody}) async {
    return await _repository!.create(
      orderId: orderId,
      refundBody: refundBody,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, OrderRefundBody? refundBody}) async {
    return await _repository!.update(
      id: id,
      refundBody: refundBody,
    );
  }
}
