import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/product_catalog.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/productCatalog.repository.dart';

class ParodiaProductCatalogProvider with ChangeNotifier {
  ProductCatalogRepository? _repository;

  ParodiaProductCatalogProvider();
  ParodiaProductCatalogProvider.init(ParodiaHTTP http) {
    _repository = ProductCatalogRepository(http);
  }

  Future<ResponseItemDTO<ProductCatalogDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<ProductCatalogDTO>> getAll(
      {ProductCatalogQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({ProductCatalogBody? productCatalog}) async {
    return await _repository!.create(
      productCatalog: productCatalog,
    );
  }

  Future<ResponseItemDTO> multiple(
      {String? id, ProductCatalogMultipleBody? productCatalogs}) async {
    return await _repository!.multiple(
      id: id,
      productCatalogs: productCatalogs,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, ProductCatalogBody? productCatalog}) async {
    return await _repository!.update(
      id: id,
      productCatalog: productCatalog,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
