import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/product_price_group.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/productPriceGroup.repository.dart';

class ParodiaProductPriceGroupProvider with ChangeNotifier {
  ProductPriceGroupRepository? _repository;

  ParodiaProductPriceGroupProvider();
  ParodiaProductPriceGroupProvider.init(ParodiaHTTP http) {
    _repository = ProductPriceGroupRepository(http);
  }

  Future<ResponseItemDTO<ProductPriceGroupDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<ProductPriceGroupDTO>> getAll(
      {StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({PriceGroupBody? priceGroup}) async {
    return await _repository!.create(
      priceGroup: priceGroup,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, PriceGroupBody? priceGroup}) async {
    return await _repository!.update(
      id: id,
      priceGroup: priceGroup,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
