import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/rating.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/productRating.repository.dart';

class ParodiaProductRatingProvider with ChangeNotifier {
  ProductRatingRepository? _repository;

  ParodiaProductRatingProvider();
  ParodiaProductRatingProvider.init(ParodiaHTTP http) {
    _repository = ProductRatingRepository(http);
  }

  Future<ResponseListDTO<RatingDTO>> getAll({
    ProductPriceAndRatingQuery? query,
  }) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, ProductRatingPutBody? rating}) async {
    return await _repository!.update(
      id: id,
      rating: rating,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
