import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/profile.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/repository/profile.repository.dart';

class ParodiaProfileProvider with ChangeNotifier {
  ProfileRepository? _repository;

  ParodiaProfileProvider();
  ParodiaProfileProvider.init(ParodiaHTTP http) {
    _repository = ProfileRepository(http);
  }

  Future<ResponseItemDTO<ProfileDTO>> get() async {
    return await _repository!.get();
  }

  Future<ResponseItemDTO> update({
    ProfilePutBody? profile,
  }) async {
    return await _repository!.update(
      profile: profile,
    );
  }

  Future<ResponseItemDTO> delete() async {
    return await _repository!.delete();
  }

  Future<ResponseItemDTO> updatePassword({
    ProfilePasswordChangeBody? profilePassword,
  }) async {
    return await _repository!.updatePassword(
      profilePassword: profilePassword,
    );
  }

  Future<ResponseItemDTO> updateEmail({
    ProfileEmailChangeBody? profileEmail,
  }) async {
    return await _repository!.updateEmail(
      profileEmail: profileEmail,
    );
  }
}
