import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/promo_code.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/promoCode.repository.dart';

class ParodiaPromoCodeProvider with ChangeNotifier {
  PromoCodeRepository? _repository;

  ParodiaPromoCodeProvider();
  ParodiaPromoCodeProvider.init(ParodiaHTTP http) {
    _repository = PromoCodeRepository(http);
  }

  Future<ResponseItemDTO<PromoCodeDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<PromoCodeDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({PromoCodeBody? promoCode}) async {
    return await _repository!.create(
      promoCode: promoCode,
    );
  }

  Future<ResponseItemDTO> update({String? id, PromoCodeBody? promoCode}) async {
    return await _repository!.update(
      id: id,
      promoCode: promoCode,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
