import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/role.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/role.repository.dart';

class ParodiaRoleProvider with ChangeNotifier {
  RoleRepository? _repository;

  ParodiaRoleProvider();
  ParodiaRoleProvider.init(ParodiaHTTP http) {
    _repository = RoleRepository(http);
  }

  Future<ResponseItemDTO<RoleDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<RoleDTO>> getAll({VariantQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({RoleBody? role}) async {
    return await _repository!.create(
      role: role,
    );
  }

  Future<ResponseItemDTO> update({String? id, RoleBody? role}) async {
    return await _repository!.update(
      id: id,
      role: role,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
