import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/role_group.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/roleGroup.repository.dart';

class ParodiaRoleGroupProvider with ChangeNotifier {
  RoleGroupRepository? _repository;

  ParodiaRoleGroupProvider();
  ParodiaRoleGroupProvider.init(ParodiaHTTP http) {
    _repository = RoleGroupRepository(http);
  }

  Future<ResponseItemDTO<RoleGroupDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<RoleGroupDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({RoleGroupBody? roleGroup}) async {
    return await _repository!.create(
      roleGroup: roleGroup,
    );
  }

  Future<ResponseItemDTO> update({String? id, RoleGroupBody? roleGroup}) async {
    return await _repository!.update(
      id: id,
      roleGroup: roleGroup,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
