import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/stock.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/stock.repository.dart';

class ParodiaStockProvider with ChangeNotifier {
  StockRepository? _repository;

  ParodiaStockProvider();
  ParodiaStockProvider.init(ParodiaHTTP http) {
    _repository = StockRepository(http);
  }

  Future<ResponseListDTO<StockDTO>> get({StockQuery? query}) async {
    return await _repository!.get(
      query: query,
    );
  }
}
