import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/stock_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/stockList.repository.dart';

class ParodiaStockListProvider with ChangeNotifier {
  StockListRepository? _repository;

  ParodiaStockListProvider();
  ParodiaStockListProvider.init(ParodiaHTTP http) {
    _repository = StockListRepository(http);
  }

  Future<ResponseItemDTO<StockListDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<StockListDTO>> get(
      {ProductPriceAndRatingQuery? query}) async {
    return await _repository!.get(
      query: query,
    );
  }

  Future<ResponseItemDTO> fix({StockListPutBody? stockList}) async {
    return await _repository!.fix(
      stockList: stockList,
    );
  }
}
