import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/rating.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/storeRating.repository.dart';

class ParodiaStoreRatingProvider with ChangeNotifier {
  StoreRatingRepository? _repository;

  ParodiaStoreRatingProvider();
  ParodiaStoreRatingProvider.init(ParodiaHTTP http) {
    _repository = StoreRatingRepository(http);
  }

  Future<ResponseListDTO<RatingDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, StoreRatingPutBody? rating}) async {
    return await _repository!.update(
      id: id,
      rating: rating,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
