import 'package:flutter/material.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/store_setting.dto.dart';
import 'package:parodia_admin/core/enums.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/repository/storeSetting.repository.dart';

class ParodiaStoreSettingProvider with ChangeNotifier {
  StoreSettingRepository? _repository;

  ParodiaStoreSettingProvider();
  ParodiaStoreSettingProvider.init(ParodiaHTTP http) {
    _repository = StoreSettingRepository(http);
  }

  Future<ResponseItemDTO<StoreSettingDTO>> get() async {
    return await _repository!.get();
  }

  Future<ResponseItemDTO> update({StoreSettingPutBody? storeSetting}) async {
    return await _repository!.update(
      storeSetting: storeSetting,
    );
  }
}
