import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/store_setting_currency.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/repository/storeSettingCurrency.repository.dart';

class ParodiaStoreSettingCurrencyProvider with ChangeNotifier {
  StoreSettingCurrencyRepository? _repository;

  ParodiaStoreSettingCurrencyProvider();
  ParodiaStoreSettingCurrencyProvider.init(ParodiaHTTP http) {
    _repository = StoreSettingCurrencyRepository(http);
  }

  Future<ResponseItemDTO<StoreSettingCurrencyDTO>> get() async {
    return await _repository!.get();
  }

  Future<ResponseItemDTO> update(
      {StoreSettingCurrencyPutBody? storeSettingCurrency}) async {
    return await _repository!.update(
      storeSettingCurrency: storeSettingCurrency,
    );
  }
}
