import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/shipment_method.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/storeShipmentMethod.repository.dart';

class ParodiaStoreShipmentMethodProvider with ChangeNotifier {
  StoreShipmentMethodRepository? _repository;

  ParodiaStoreShipmentMethodProvider();
  ParodiaStoreShipmentMethodProvider.init(ParodiaHTTP http) {
    _repository = StoreShipmentMethodRepository(http);
  }

  Future<ResponseItemDTO<ShipmentMethodDTO>> getById({String? id}) async {
    return await _repository!.getById(id: id);
  }

  Future<ResponseListDTO<ShipmentMethodDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(query: query);
  }

  Future<ResponseItemDTO> create(
      {StoreShipmentMethodBody? shipmentMethod}) async {
    return await _repository!.create(shipmentMethod: shipmentMethod);
  }

  Future<ResponseItemDTO> update(
      {StoreShipmentMethodBody? shipmentMethod, String? id}) async {
    return await _repository!.update(shipmentMethod: shipmentMethod, id: id);
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(id: id);
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(id: id);
  }
}
