import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/suggestion.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/suggestion.repository.dart';

class ParodiaSuggestionProvider with ChangeNotifier {
  SuggestionsRepository? _repository;

  ParodiaSuggestionProvider();
  ParodiaSuggestionProvider.init(ParodiaHTTP http) {
    _repository = SuggestionsRepository(http);
  }

  Future<ResponseListDTO<SuggestionDTO>> getAll(
      {SuggestionQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> solve({String? id}) async {
    return await _repository!.solve(
      id: id,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
