import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/supplier.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/supplier.repository.dart';

class ParodiaSupplierProvider with ChangeNotifier {
  SupplierRepository? _repository;

  ParodiaSupplierProvider();
  ParodiaSupplierProvider.init(ParodiaHTTP http) {
    _repository = SupplierRepository(http);
  }

  Future<ResponseItemDTO<SupplierDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<SupplierDTO>> getAll({
    StoreQuery? query,
  }) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({SupplierBody? supplier}) async {
    return await _repository!.create(
      supplier: supplier,
    );
  }

  Future<ResponseItemDTO> update({String? id, SupplierBody? supplier}) async {
    return await _repository!.update(
      id: id,
      supplier: supplier,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
