import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/tax.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/tax.repository.dart';

class ParodiaTaxProvider with ChangeNotifier {
  TaxRepository? _repository;

  ParodiaTaxProvider();
  ParodiaTaxProvider.init(ParodiaHTTP http) {
    _repository = TaxRepository(http);
  }

  Future<ResponseItemDTO<TaxDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<TaxDTO>> getAll({
    StoreQuery? query,
  }) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({TaxBody? tax}) async {
    return await _repository!.create(
      tax: tax,
    );
  }

  Future<ResponseItemDTO> update({String? id, TaxBody? tax}) async {
    return await _repository!.update(
      id: id,
      tax: tax,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
