import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/theme.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/theme.repository.dart';

class ParodiaThemeProvider with ChangeNotifier {
  ThemeRepository? _repository;

  ParodiaThemeProvider();
  ParodiaThemeProvider.init(ParodiaHTTP http) {
    _repository = ThemeRepository(http);
  }

  Future<ResponseItemDTO<ThemeDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<ThemeDTO>> getAll({
    StoreQuery? query,
  }) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({ThemeBody? theme}) async {
    return await _repository!.create(
      theme: theme,
    );
  }

  Future<ResponseItemDTO> update({String? id, ThemeBody? theme}) async {
    return await _repository!.update(
      id: id,
      theme: theme,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
