import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/repository/ticketCategory.repository.dart';

class ParodiaTicketCategoryProvider with ChangeNotifier {
  TicketCategoryRepository? _repository;

  ParodiaTicketCategoryProvider();
  ParodiaTicketCategoryProvider.init(ParodiaHTTP http) {
    _repository = TicketCategoryRepository(http);
  }

  Future<ResponseItemDTO> create({TicketCategoryBody? ticketCategory}) async {
    return await _repository!.create(
      ticketCategory: ticketCategory,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, TicketCategoryBody? ticketCategory}) async {
    return await _repository!.update(
      id: id,
      ticketCategory: ticketCategory,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
