import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/user_group.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/userGroup.repository.dart';

class ParodiaUserGroupProvider with ChangeNotifier {
  UserGroupRepository? _repository;

  ParodiaUserGroupProvider();
  ParodiaUserGroupProvider.init(ParodiaHTTP http) {
    _repository = UserGroupRepository(http);
  }
  Future<ResponseItemDTO<UserGroupDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<UserGroupDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({UserGroupBody? userGroup}) async {
    return await _repository!.create(
      userGroup: userGroup,
    );
  }

  Future<ResponseItemDTO> update({String? id, UserGroupBody? userGroup}) async {
    return await _repository!.update(
      id: id,
      userGroup: userGroup,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
