import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/profile.dto.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/users.repository.dart';

class ParodiaUserProvider with ChangeNotifier {
  UserRepository? _repository;

  ParodiaUserProvider();
  ParodiaUserProvider.init(ParodiaHTTP http) {
    _repository = UserRepository(http);
  }

  Future<ResponseItemDTO<ProfileDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<ProfileDTO>> getAll({StoreUserQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({UserBody? user}) async {
    return await _repository!.create(
      user: user,
    );
  }

  Future<ResponseItemDTO> update({String? id, UserBody? user}) async {
    return await _repository!.update(
      id: id,
      user: user,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
