import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/variant_group.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/variantGroup.repository.dart';

class ParodiaVariantGroupProvider with ChangeNotifier {
  VariantGroupRepository? _repository;

  ParodiaVariantGroupProvider();
  ParodiaVariantGroupProvider.init(ParodiaHTTP http) {
    _repository = VariantGroupRepository(http);
  }

  Future<ResponseItemDTO<VariantGroupDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<VariantGroupDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({VariantGroupBody? variantGroup}) async {
    return await _repository!.create(
      variantGroup: variantGroup,
    );
  }

  Future<ResponseItemDTO> update(
      {String? id, VariantGroupBody? variantGroup}) async {
    return await _repository!.update(
      id: id,
      variantGroup: variantGroup,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
