import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/vehicle.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/vehicle.repository.dart';

class ParodiaVehicleProvider with ChangeNotifier {
  VehicleRepository? _repository;

  ParodiaVehicleProvider();
  ParodiaVehicleProvider.init(ParodiaHTTP http) {
    _repository = VehicleRepository(http);
  }

  Future<ResponseItemDTO<VehicleDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<VehicleDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({VehicleBody? vehicle}) async {
    return await _repository!.create(
      vehicle: vehicle,
    );
  }

  Future<ResponseItemDTO> update({String? id, VehicleBody? vehicle}) async {
    return await _repository!.update(
      id: id,
      vehicle: vehicle,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
