import 'package:flutter/material.dart';
import 'package:parodia_admin/core/dto/response_item.dto.dart';
import 'package:parodia_admin/core/dto/response_list.dto.dart';
import 'package:parodia_admin/core/dto/warehouse.dto.dart';
import 'package:parodia_admin/core/http/parodia_http.dart';
import 'package:parodia_admin/core/model/body_data.model.dart';
import 'package:parodia_admin/core/model/query.model.dart';
import 'package:parodia_admin/core/repository/warehouse.repository.dart';

class ParodiaWarehouseProvider with ChangeNotifier {
  WarehouseRepository? _repository;

  ParodiaWarehouseProvider();
  ParodiaWarehouseProvider.init(ParodiaHTTP http) {
    _repository = WarehouseRepository(http);
  }

  Future<ResponseItemDTO<WarehouseDTO>> getById({String? id}) async {
    return await _repository!.getById(
      id: id,
    );
  }

  Future<ResponseListDTO<WarehouseDTO>> getAll({StoreQuery? query}) async {
    return await _repository!.getAll(
      query: query,
    );
  }

  Future<ResponseItemDTO> create({WarehouseBody? warehouse}) async {
    return await _repository!.create(
      warehouse: warehouse,
    );
  }

  Future<ResponseItemDTO> update({String? id, WarehouseBody? warehouse}) async {
    return await _repository!.update(
      id: id,
      warehouse: warehouse,
    );
  }

  Future<ResponseItemDTO> delete({String? id}) async {
    return await _repository!.delete(
      id: id,
    );
  }

  Future<ResponseItemDTO> recover({String? id}) async {
    return await _repository!.recover(
      id: id,
    );
  }
}
